#pragma once

#include "FltkListener.h"
#include "Point.h"

#include <FL/Fl_widget.h>

class CameraHandler : public FltkListener
{
private:
	typedef Point::triple triple;
	double theta_;
	double phi_;

	double maxTheta;
	double minTheta;

	double maxPhi;
	double minPhi;

	double r;

	triple focus;

	bool rMouseDown;
	float rMouseX;
	float rMouseY;

	Fl_Widget* parent;

	static const double PI;

public:
	CameraHandler(double, double, double, double, double, double, double, Fl_Widget*);
	~CameraHandler(void);

	double phi() {return phi_ / 360 * 2 * PI;}
	double theta() {return theta_ / 360 * 2 * PI;}

	void focus_point(double x, double y, double z) {focus = triple(x,y,z);}
	void focus_point(triple fp) {focus = fp;}

	int process(int);
	void projection(Point);
	void projection();
};

