#pragma once

#include "Curve.h"
#include "train.h"

#include <vector>
#include <stack>


class Coaster : public Renderable
{
private:
	Curve curve;
	train train_;

	typedef Point::triple triple;

	std::vector<triple> left_rail_;
	std::vector<triple> right_rail_;
	std::vector<triple> rail_ties_;

	std::vector<std::pair<triple, triple> > up_dir_;
	std::vector<triple> out_;
public:
	Coaster(void);
	~Coaster(void);

	train* train() {return &train_;}

	Curve* getCurve() {return &curve;}

	void drawThis();

	bool select(double p[3], double d[3]) {return curve.select(p, d);}
	bool hover(double p[3], double d[3]) {return curve.hover(p, d);}
};
