#pragma once

#include "Renderable.h"

#include <vector>
#include <iostream>
#include <fstream>


class ControlPoint : public Renderable
{
private:
	std::vector<double> pos;
	float radius;
	float rot;

	bool isSelected;
	bool isHovered;

public:
	ControlPoint(void);
	~ControlPoint(void);

	void write(std::ofstream& file) {file << pos[0] << " " << pos[1] << " " << pos[2] << std::endl;}
	static ControlPoint read(std::ifstream& file) {double x, y, z; ControlPoint cp; file >> x; file >> y; file >> z; cp.x(x); cp.y(y); cp.z(z); cp.isSelected = false; cp.isHovered = false; return cp;}
	void x(double);
	double x();

	void y(double);
	double y();

	void z(double);
	double z();

	std::vector<double> position() {return pos;}

	void dx(double);
	void dy(double);
	void dz(double);


	void drawThis();

	bool pick(double[3], double[3]);
	double squaredDistance(double[3]);

	void select();
	void deselect();

	void hover();
	void deHover();

	void update(int = 1);

};

inline void ControlPoint::dx(double d) {pos[0] += d;}
inline void ControlPoint::dy(double d) {pos[1] += d;}
inline void ControlPoint::dz(double d) {pos[2] += d;}

inline void ControlPoint::x(double x) {pos[0] = x;}
inline double ControlPoint::x() {return pos[0];}


inline void ControlPoint::y(double y) {pos[1] = y;}
inline double ControlPoint::y() {return pos[1];}


inline void ControlPoint::z(double z) {pos[2] = z;}
inline double ControlPoint::z() {return pos[2];}