#include "CoasterUI.h"
#include "global.h"

#include <FL/Fl.h>

#include <ctime>

using namespace std;

void idle(void* cui)
{
		double seconds = 0.001;
		clock_t wait;
		wait = clock () + seconds * CLOCKS_PER_SEC ;
		while (clock() < wait) {}

		static_cast<CoasterUI*>(cui)->damage(1);
		Config::instance().change(0);
}

int main(int args, char** argc)
{
	Config& cfg = Config::instance();

	CoasterUI ui;
	ui.make_window();
	ui.window->show();
	ui.CoasterWind->show();
	ui.SideWind->show();

	CoasterWorld* cw = new CoasterWorld();
	
	cfg.world(cw);
	cfg.ui(&ui);

	Fl::add_idle(&idle, &ui);

	ui.spline_type_->add("Cardinal");
	ui.spline_type_->add("B-Spline");

	ui.focus_->add("Selected Normal");
	ui.focus_->add("Selected Control");
	ui.focus_->add("Origin");
	ui.focus_->add("Train");	

	cfg.ready();

	Fl::run();
	return 1;
}