#pragma once

#include "FltkListener.h"
#include "CoasterWorld.h"

#include <FL/Fl_Widget.h>

class CoasterWorld;

class PointSelector : public FltkListener
{
private:
	Fl_Widget* parent;

	bool active;
	
	double model[16];
	double proj[16];
	int vp[4];

public:
	PointSelector(Fl_Widget* p) : parent(p), active(true) {}
	~PointSelector(void);

	void update();

	void deactivate() {active = false;}

	void select_norm_dir(double, double, double, double, double, double, double, double, double&, double&, double&);
	
	void select_z_plane(double, double, double , double& , double& );
	void select_z(double, double, double, double, double, double&);

	int process(int);
};
