#include "Renderable.h"
#include "Config.h"

#include "global.h"

#include <windows.h>
#include <FL/Gl.h>

using namespace std;

Config& Renderable::cfg = Config::instance();

Renderable::Renderable(void)
{
}

Renderable::~Renderable(void)
{
}


void Renderable::add(Renderable* n)
{
	children.push_back(n);
}

void Renderable::draw()
{
	glMatrixMode(GL_MODELVIEW);

	glEnable(GL_POLYGON_OFFSET_FILL);
	glPolygonOffset(0.001, 1.0);


	glPushMatrix();
	
	if (cfg.animate())
		update();
	
	drawThis();

	vector<Renderable*>::iterator iter;
	for (iter = children.begin(); iter != children.end(); iter++)
		(*iter)->draw();

	glPopMatrix();
}

bool Renderable::select(double p[3], double d[3])
{
	bool result = false;

	vector<Renderable*>::iterator iter;
	for (iter = children.begin(); iter != children.end(); iter++)
		result = result || (*iter)->select(p, d);

	Config::instance().refresh_data();

	return result;
}

bool Renderable::hover(double p[3], double d[3])
{
	bool result = false;

	vector<Renderable*>::iterator iter;
	for (iter = children.begin(); iter != children.end(); iter++)
		result = result || (*iter)->hover(p, d);

	return result;
}

	