#pragma once



#include <vector>
#include <stack>
#include <queue>

class Config;

class Renderable
{
private:
	
	std::vector<Renderable*> children;
public:
	static Config& cfg;
	Renderable(void);
	virtual ~Renderable(void);

	void add(Renderable* n);

	void draw();

	virtual bool select(double[3], double[3]);
	virtual bool hover(double[3], double[3]);

	virtual void drawThis() {}

	virtual void update(int = 1) {}
};

