#include "train.h"
#include "tree_renderable.h"
#include "Config.h"
#include "curve.h"

#include <windows.h>
#include <Fl/Gl.h>

#include <iostream>

#include <cmath>


#include "front_car.h"
#include "train_car.h"

using namespace std;

train::train(void) : length(0.5), dl(0.5), min_dl(0.05)
{
	
}

train::~train(void)
{
}

void train::update(int)
{
	pos_ = cfg.curve()->point_at_length(length);
	dl += cfg.gravity() * (last.position().z - pos_.position().z);
	dl *= cfg.friction();
	dl = max<double>(min_dl, dl);
	length += cfg.speed() * dl;
	length = length > cfg.curve()->length() ? length - cfg.curve()->length() : length;
	last = pos_;
}

void train::drawThis()
{
	glColor3f(0.3, 0.3, 0.6);
	front_car::draw(length);

	double red = 0.25, green = 0.35, blue = 0.5;

	double num_cars = cfg.cars();
	double l = length - 15;

	for (int i = 0; i < num_cars; ++i, red -= 0.05, green += 0.05, blue -= 0.05, l -= 9) {
		red = max<double>(red, 0);
		blue = max<double>(blue, 0);
		green = min<double>(green, 1);
		glColor3f(red, green, blue);
		train_car::draw(l);
	}
}