#include "train_car.h"

#include "global.h"
#include "wheels.h"
#include "person.h"

#include <Fl/Glut.h>

train_car::train_car(void)
{
}

train_car::~train_car(void)
{
}


void train_car::draw(double l)
{
	glPushMatrix();
	typedef Point::triple triple;
	Config& cfg = Config::instance();
	

	Point front = cfg.curve()->simple_point_at_length(l);
	Point back = cfg.curve()->simple_point_at_length(l - 10);

	Point middle = cfg.curve()->point_at_length(l - 5);

	triple up, out, dir, fpos, bpos, pos;
	up = middle.normal();
	out = middle.out();

	fpos = front.position();
	bpos = back.position();

	dir = fpos - bpos;
	dir.normalize();

	pos = 0.5 * fpos + 0.5 * bpos;

	glTranslatef(pos.x, pos.y, pos.z);

	gl_rotate(dir, out, up);

	glPushMatrix();
	glTranslatef(0, 0, 2);
	glScalef(2, 1.8, 2); 
	glutSolidCube(2);
	glPopMatrix();
	glPushMatrix();
	glTranslatef(4, 0, 1.5);
	glScalef(2, 1.8, 1.5); 
	glutSolidCube(2);
	glPopMatrix();

	triple v1, v2, v3, v4, v5, v6;
	v1 = triple(6, 1.8, 3);
	v2 = triple(6, -1.8, 3);
	v3 = triple(2, 1.8, 3);
	v4 = triple(2, -1.8, 3);
	v5 = triple(2, 1.8, 4);
	v6 = triple(2, -1.8, 4);

	glBegin(GL_TRIANGLES);
		v1.draw();
		v3.draw();
		v5.draw();
		v2.draw();
		v6.draw();
		v4.draw();
	glEnd();

	glBegin(GL_QUADS);
		v1.draw();
		v5.draw();
		v6.draw();
		v2.draw();
	glEnd();

	glPopMatrix();

	person::draw(Point(pos, middle.normal(), middle.direction()));
	
	wheels::draw(l - 0.5);
	wheels::draw(l - 5);

}