#include "wheels.h"

#include "global.h"

using namespace std;

wheels::wheels(void)
{
}

wheels::~wheels(void)
{
}

void wheels::draw_wheels() {
	glColor3f(0.5, 0.2, 0.2);
	typedef Point::triple triple;
	
	double theta = 0;
	vector<triple> circle1, circle2, quads1, quads2;
	for (; theta < 2 * 3.1415927; theta += 3.1415927 / 10)
	{
		double x, z;
		x = 1.2 * sin(theta);
		z = 1.2 * cos(theta);
		triple c1, c2, q1, q2;
		c1 = triple(x, 2.2, z);
		c2 = triple(x, -2.2, z);
		q1 = triple(x, 1.8, z);
		q2 = triple(x, -1.8, z);
		circle1.push_back(c1);
		circle2.push_back(c2);
		quads1.push_back(c1);
		quads1.push_back(q1);
		quads2.push_back(q2);
		quads2.push_back(c2);
		
	}

	vector<triple> spokes;
	for (theta = 0; theta < 2 * 3.1415927; theta += 3.1415927 / 3) {
		double x, z;
		x = 1.2 * sin(theta);
		z = 1.2 * cos(theta);
		triple s1, s2, s3, s4;
		s1 = triple(x, 2.22, z);
		s2 = triple(0, 2.21, 0);
		s3 = triple(x, -2.22, z);
		s4 = triple(0, -2.21, 0);
		spokes.push_back(s1);
		spokes.push_back(s2);
		spokes.push_back(s3);
		spokes.push_back(s4);
	}

	
	vector<triple>::iterator iter;
	vector<triple>::reverse_iterator riter;

	glBegin(GL_POLYGON);
	iter = circle1.end() - 1;
	iter->draw();
	for (iter = circle1.begin(); iter != circle1.end(); ++iter)
		iter->draw();
	glEnd();

	glBegin(GL_POLYGON);
	riter = circle2.rend() - 1;
	riter->draw();
	for (riter = circle2.rbegin(); riter != circle2.rend(); ++riter)
		riter->draw();
	glEnd();


	glColor3f(0, 0, 1);

	glBegin(GL_QUAD_STRIP);
	iter = quads1.end() - 2;
	iter++->draw();
	iter->draw();
	for (iter = quads1.begin(); iter != quads1.end(); ++iter)
		iter->draw();
	glEnd();


	glBegin(GL_QUAD_STRIP);
	iter = quads2.end() - 2;
	iter++->draw();
	iter->draw();
	for (iter = quads2.begin(); iter != quads2.end(); ++iter)
		iter->draw();
	glEnd();

	glColor3f(0.4, 0.4, 0.4);
	glBegin(GL_LINES);
	for (iter = spokes.begin(); iter != spokes.end(); ++iter)
		iter->draw();
	glEnd();
		
		
}


void wheels::draw(double l) {
	glPushMatrix();

	double circ = 25;
	Point p = Config::instance().curve()->point_at_length(l);
	typedef Point::triple triple;

	triple pos = p.position(), dir = p.direction(), up = p.normal(), out = p.out();

	double theta = fmod(l, circ) / circ * 360;
		
	glTranslatef(pos.x, pos.y, pos.z);
	
	gl_rotate(dir, out, up);

	glTranslatef(0, 0, 0.5);

	glRotatef(theta, 0, 1, 0);
	draw_wheels();

	glPopMatrix();
}
